import mimetools
import multifile
import re
import string

from globals import *
import ezmlm
import output

class Output:
	def __init__(self):
		self.data = [ ]
	def write(self, data):
		self.data.append(data)
	def __str__(self):
		return string.join(self.data)

def show_part(form, part, mf):
	form[TYPE] = part.type
	if part.maintype == 'multipart':
		for item in part.plist:
			if item[:9] == 'boundary=':
				boundary = item[9:]
				if boundary[0] == '"' and boundary[-1] == '"':
					boundary = boundary[1:-1]
		mf.push(boundary)
		while 1:
			if not mf.next(): break
			show_part(form, mimetools.Message(mf), mf)
		mf.pop()
	elif part.type == 'text/plain' or part.type == 'message/rfc822':
		eh = string.lower(part.encodingheader or '')
		if eh and eh <> '7bit' and eh <> '8bit':
			body = Output()
			mimetools.decode(mf, body, eh)
			body = str(body)
		else:
			body = string.join(mf.readlines(), '')
		form[BODY] = body
		output.format('text-plain', form)
	else:
		output.format('omitted', form)

def show(form):
	msg = ezmlm.open_message(form)
	mf = multifile.MultiFile(msg)
	msg = mimetools.Message(mf)
	sender = output.mask_email(msg.getheader('from'))
	form[FROM] = sender
	form[SUBJECT] = msg.getheader('subject')
	form[DATE] = msg.getheader('date')
	output.format('head', form)
	show_part(form, msg, mf)
	output.format('tail', form)
